# -*- coding: utf-8 -*-
"""
Created on Thu May 31 14:22:48 2018

@author: Usuario
"""

from pyqtgraph.Qt import QtGui
from myWidgets import anal_control_signal, digital_control_signal
from pyqtgraph.Qt import QtWidgets

#This creates the window for the gui
app = QtGui.QApplication([])

win = QtGui.QMainWindow()
win.setWindowTitle('pyqtgraph example: SpinBox')
cw = QtGui.QWidget()
layout = QtGui.QGridLayout()
cw.setLayout(layout)
win.setCentralWidget(cw)
win.show()



layout397 = QtGui.QGridLayout()
layout866 = QtGui.QGridLayout()
layoutPI = QtGui.QGridLayout()
layoutIMG = QtGui.QGridLayout()
layout397_scan = QtGui.QGridLayout()

layout.addLayout(layout397, 1, 1)
layout.addLayout(layout866, 2, 1)
layout.addLayout(layoutPI, 3, 1)
layout.addLayout(layoutIMG, 4, 1)
layout.addLayout(layout397_scan, 1, 2)

l1 = QtGui.QLabel()
l1.setGeometry(50, 50, 25, 25)
pixmap = QtGui.QPixmap("snuffles.png")
pixmap = pixmap.scaledToWidth(100)
l1.setPixmap(pixmap)
layoutIMG.addWidget(l1)


############ creating the controls ########################

piezoA397 = anal_control_signal('piezoA397', 0)
piezoB397 = anal_control_signal('piezoB397', 1)
piezoA866 = anal_control_signal('piezoA866', 2)
piezoB866 = anal_control_signal('piezoB866', 3)
piezoA423 = anal_control_signal('piezoA423', 4)

shutter397 = digital_control_signal('shutter397', 0)
shutter866 = digital_control_signal('shutter866', 2)
shutter423 = digital_control_signal('shutter423', 1)
shutterLED = digital_control_signal('shutterLED', 3)


button = QtWidgets.QPushButton('Touch me, babe')

######### 397 ###########
layout397.addWidget(QtGui.QLabel('397'), 0, 0)
layout397.addWidget(QtGui.QLabel(piezoA397.name), 1, 1), layout397.addWidget(piezoA397.sb, 1, 2)
layout397.addWidget(QtGui.QLabel(piezoB397.name), 2, 1), layout397.addWidget(piezoB397.sb, 2, 2)
layout397.addWidget(QtGui.QLabel(shutter397.name), 3, 1), layout397.addWidget(shutter397.cb, 3, 2)

layout397_scan.addWidget(button, 1, 3)
#layout397.addWidget(QtGui.QLabel('shutter'), 3, 1), layout397.addWidget(shutter397, 3, 2)
#########################

######### 866 ###########
layout866.addWidget(QtGui.QLabel('866'), 0, 0)
layout866.addWidget(QtGui.QLabel(piezoA866.name), 1, 1), layout866.addWidget(piezoA866.sb, 1, 2)
layout866.addWidget(QtGui.QLabel(piezoB866.name), 2, 1), layout866.addWidget(piezoB866.sb, 2, 2)
layout866.addWidget(QtGui.QLabel(shutter866.name), 3, 1), layout866.addWidget(shutter866.cb, 3, 2)
#########################

######### PI ###########
layoutPI.addWidget(QtGui.QLabel('Photoion'), 0, 0)
layoutPI.addWidget(QtGui.QLabel(piezoA423.name), 1, 1), layoutPI.addWidget(piezoA423.sb, 1, 2)
layoutPI.addWidget(QtGui.QLabel(shutter423.name), 2, 1), layoutPI.addWidget(shutter423.cb, 2, 2)
layoutPI.addWidget(QtGui.QLabel(shutterLED.name), 3, 1), layoutPI.addWidget(shutterLED.cb, 3, 2)
#########################


######### Here I define the connect functions ###########

def whenChangeAnalog(sb, daq):
    daq.set_out(sb.value())
    
def whenChangeDigital(cb, daq):
    daq.set_out(not cb.isChecked())
    


piezoA397.sb.sigValueChanging.connect(lambda: whenChangeAnalog(piezoA397.sb, piezoA397.AO))
piezoB397.sb.sigValueChanging.connect(lambda: whenChangeAnalog(piezoB397.sb, piezoB397.AO))
piezoA866.sb.sigValueChanging.connect(lambda: whenChangeAnalog(piezoA866.sb, piezoA866.AO))
piezoB866.sb.sigValueChanging.connect(lambda: whenChangeAnalog(piezoB866.sb, piezoB866.AO))
piezoA423.sb.sigValueChanging.connect(lambda: whenChangeAnalog(piezoA423.sb, piezoA423.AO))


shutter397.cb.stateChanged.connect(lambda: whenChangeDigital(shutter397.cb, shutter397.DO))
shutter866.cb.stateChanged.connect(lambda: whenChangeDigital(shutter866.cb, shutter866.DO))
shutter423.cb.stateChanged.connect(lambda: whenChangeDigital(shutter423.cb, shutter423.DO))
shutterLED.cb.stateChanged.connect(lambda: whenChangeDigital(shutterLED.cb, shutterLED.DO))

#%%

import time
i = 0
t = 1.5
time.sleep(1)
while(i<10):
    
    shutter397.DO.set_out(0)
    shutter423.DO.set_out(1)
    shutter866.DO.set_out(1)
    
    time.sleep(t)    
    
    shutter397.DO.set_out(1)
    shutter423.DO.set_out(0)
    shutter866.DO.set_out(1)
    
    
    time.sleep(t)    
    
    shutter397.DO.set_out(1)
    shutter423.DO.set_out(1)
    shutter866.DO.set_out(0)
    
    
    time.sleep(t)
    
    
    i = i + 1
    
print('iteration finished')
#%%

###########################################################
#all shutter start in False: 
shutters = [shutter397, shutter866, shutter423, shutterLED]
for sh in shutters:
    sh.DO.set_out(True)
